﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MQTTnet;
using MQTTnet.Client;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using ModbusDemo.windows;
using ModbusDemo;
using ModbusDemo.Modular;
using ModbusDemo.Common;
using System.Threading;
using ModbusDemo.application;
using System.Windows.Forms;
using System.IO;
namespace ModbusDemo.MessageFormat
{
    public class ModualControl
    {
        public class OpItem
        {
            public int d0 { get; set; }
            public int d2 { get; set; }
            public int d3 { get; set; }
            public int d4 { get; set; }
            public int d5 { get; set; }
            public int d6 { get; set; }
            public int d7 { get; set; }
            public int duration { get ;set;}
            public UInt64 startTime { get ;set;}

        }
        public class SsItem
        {
            public string addr { get; set; }

            public List <OpItem > op { get; set; }
        }
        public class MqttRoot
        {

            public string taskId { get; set; }
            public List <SsItem > ss { get; set; }
        }
        public class Cfg
        {
            public byte d0 { get; set; }
            public byte d1 { get; set; }
            public byte d2 { get; set; }
            public byte d3 { get; set; }
            public byte d4 { get; set; }
            public byte d5 { get; set; }
            public byte d6 { get; set; }
            public byte d7 { get; set; }
            public string name {get; set; }
            public string down { get; set; }
            public string upper { get; set; }
            public UInt64 ts { get; set; }
        }
        public class pcCfgSsItem
        {
            public string addr { get; set; }
            public Cfg cfg { get; set; }
        }

        public class pcCfgRoot
        {
            public string taskId { get; set; }
            public List<pcCfgSsItem> ss { get; set; }
        }

        public class pcModualControlIndex
        {
            public string srcId   { get; set; }
            public string srcType { get; set; }
            public string srcCh   { get; set; }
            public string opType  {get;  set; }
            public string resId   { get; set; }
            public string resType { get; set; }
            public string resCh   { get; set; }
            public List<string> dstCh { get; set; }
        }

        public class pcControlMap
        {
            public List<pcModualControlIndex> chMap { get; set; }
        }
        public class ModualCntrol
        {
            public bool bStartControl;
            public bool bControlStatus;
            public byte sbModbusID;
            public byte sbModualIndex;
            public bool[] bControlData;
            public ushort usDurationTime;
            public UInt64 ulStartTime;
            public bool[] bControlBit = new bool[8];
            public modual.eModualType eModualType;
            public bool  bOpenMachine;
            public string[] strOperationChannelName;
        }

        private const double OPENCURRENT  = 7;
        private const double CLOSECURRENT = 6;
        public class pcLiquidLevelConfig
        {
            public byte         byModbusID;
            public string       stChannelNumber;
            public double       dUpLevel;
            public double       dDownLevel;
        }
        public static List<pcLiquidLevelConfig> cPoolLevelConfig = new List<pcLiquidLevelConfig>();
        public static List<ModualCntrol> liModuualControl = new List<ModualCntrol>();
        public const  ushort usDefineControlTimes = 1;
        public static FileInfo filConfigFiles = new FileInfo(pcConfig.FileName);
        private static object obLock = new object();
#if DEBUG_TEST
        public const string strMapCfg = "{chMap:[" +
                                                "{ \"srcId\": \"31\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d1\", \"dstCh\":[\"d1\",\"d2\"],\"resId\":\"13\",\"resType\":\"WTDR78C\",\"resCh\":\"d2\"}," +

                                                "{ \"srcId\": \"16\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d0\", \"dstCh\":[\"d0\",\"d1\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                "{ \"srcId\": \"16\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d2\", \"dstCh\":[\"d2\",\"d3\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +

                                                "{ \"srcId\": \"35\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d0\", \"dstCh\":[\"d0\",\"d1\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                "{ \"srcId\": \"35\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d2\", \"dstCh\":[\"d2\",\"d3\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," + 

                                                "{ \"srcId\": \"39\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d0\", \"dstCh\":[\"d0\",\"d1\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                "{ \"srcId\": \"39\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d2\", \"dstCh\":[\"d2\",\"d3\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +


                                                //"{ \"srcId\": \"13\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d0\", \"dstCh\":[\"d0\",\"d1\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                //"{ \"srcId\": \"13\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d2\", \"dstCh\":[\"d2\",\"d3\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                //"{ \"srcId\": \"13\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d4\", \"dstCh\":[\"d4\",\"d5\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                                //"{ \"srcId\": \"13\", \"srcType\": \"WTDR66C\", \"srcCh\":\"d6\", \"dstCh\":[\"d6\",\"d7\"],\"resId\":\"23\",\"resType\":\"WTDR78C\",\"resCh\":\"d0\"}," +
                                        "]}";
#endif
        public static void vGetaWay_Receive_Control(string sDataString, out string stResponseData)
        {
            MqttRoot cControl = new MqttRoot();
            var jsonObj = new JObject();
            try
            {
                cControl = JsonConvert.DeserializeObject<MqttRoot>(sDataString);
                jsonObj  = JObject.Parse(sDataString);
            }
            catch (Exception exception)
            {
                Form1.totxt.Log(exception + "Control Mqtt Parse Fail");
            }
            for (int i = 0; i < cControl.ss.Count; i++)
            {
                for (int m = 0; m < cControl.ss[i].op.Count(); m++)
                {
                    List<string> strOperation = new List<string>();
                    bool[] bOperationStatus = new bool[8] { false, false, false, false, false, false, false, false };
                    ModualCntrol cModualCntrol = new ModualCntrol
                    {
                        sbModbusID = byte.Parse(cControl.ss[i].addr),
                        usDurationTime = (ushort)(cControl.ss[i].op[m].duration * 60),
                        ulStartTime = cControl.ss[i].op[m].startTime
                    };
                    cModualCntrol.bControlStatus = ModualPoll.bGet_channel_Value<bool>(cModualCntrol.sbModbusID, out cModualCntrol.bControlData, "d0", "d1", "d2", "d3", "d4", "d5","d6");
                    if (jsonObj["ss"][i]["op"][m] != null)
                    {
                        string str;
                        for (int j = 0; j < 8; j++)
                        {
                            str = "d" + j.ToString();
                            if (jsonObj["ss"][i]["op"][m][str] != null)
                            {
                                if (Convert.ToBoolean(jsonObj["ss"][i]["op"][m].Value<int>(str)) == true)
                                {
                                    cModualCntrol.bControlData[j] = true;
                                    cModualCntrol.bOpenMachine = true;
                                }
                                else
                                {
                                    cModualCntrol.bControlData[j] = false;
                                    cModualCntrol.bOpenMachine = false;
                                }
                                cModualCntrol.bControlBit[j] = true;
                                strOperation.Add(str);
                            }
                        }
                    }
                    if (jsonObj["ss"][i]["op"][m]["ts"] != null)
                    {
                        jsonObj["ss"][i]["op"][m]["ts"] = Form1.GetTimeStamp();
                    }
                    cModualCntrol.strOperationChannelName = strOperation.ToArray();
                    if (cModualCntrol.bControlStatus == true && cModualCntrol.ulStartTime <= Form1.GetTimeStamp())
                    {
                        cModualCntrol.bStartControl = true;
                        for (int j = 0; j < cModualCntrol.strOperationChannelName.Count(); j++)
                        {
                            if (bNorth_South_Water_Mutual_Check (cModualCntrol.sbModbusID,cModualCntrol.strOperationChannelName[j]) && ControlMap.bControl_Map(cModualCntrol.bOpenMachine, cModualCntrol.sbModbusID, cModualCntrol.bControlData, cModualCntrol.strOperationChannelName[j]))
                            {
                                bOperationStatus[j] = ControlMap.bDelege_Operation(cModualCntrol.bControlData);
                                cModualCntrol.bControlStatus = bOperationStatus[j];
                            }
                            else
                            {
                                cModualCntrol.bControlStatus = false;
                                bOperationStatus[j] = false;
                            }
                        }
                    }
                    if (cModualCntrol.bControlStatus == true && cModualCntrol.strOperationChannelName.Count() <= 1)
                    {
                        lock (obLock)
                        {
                            vDelete_Same_Control(cModualCntrol);
                            if (cModualCntrol.bStartControl == true && cModualCntrol.ulStartTime != 0 && cModualCntrol.bControlStatus == true)
                            {
                                liModuualControl.Add(cModualCntrol);
                            }
                            else if (cModualCntrol.bStartControl == false && cModualCntrol.ulStartTime != 0)
                            {
                                liModuualControl.Add(cModualCntrol);
                            }
                        }
                    }
                    for (int k = 0; k < 8; k++)
                    {
                        if (cModualCntrol.bControlBit[k] == true && (cModualCntrol.bControlStatus == true || bOperationStatus[k] == true))
                        {
                            string str = "d" + k.ToString();
                            jsonObj["ss"][i]["op"][m][str] = 1;
                        }
                        else if (cModualCntrol.bControlBit[k] == true)
                        {
                            string str = "d" + k.ToString();
                            jsonObj["ss"][i]["op"][m][str] = 0;
                        }
                    }
                }
            }
            stResponseData = jsonObj.ToString();
        }

        public static void vControl_Poll()
        {
            while (true)
            {
                lock (obLock)
                {
                    for (sbyte i = 0; i < liModuualControl.Count; i++)
                    {
                        if (liModuualControl[i].bStartControl == false)
                        {
                            if (liModuualControl[i].ulStartTime <= Form1.GetTimeStamp())
                            {
                                liModuualControl[i].bStartControl = true;
                                bool[] bControlData;
                                liModuualControl[i].bControlStatus = ModualPoll.bGet_channel_Value<bool>(liModuualControl[i].sbModbusID, out bControlData, "d0", "d1","d2", "d3", "d4", "d5", "d6", "d7");
                                if (bNorth_South_Water_Mutual_Check (liModuualControl[i].sbModbusID,liModuualControl[i].strOperationChannelName[0]) && ControlMap.bControl_Map(liModuualControl[i].bOpenMachine, liModuualControl[i].sbModbusID, liModuualControl[i].bControlData, liModuualControl[i].strOperationChannelName[0]))
                                {
                                    liModuualControl[i].bControlStatus = ControlMap.bDelege_Operation(bControlData);
                                }
                            }
                        }
                        else
                        {
                            if ((liModuualControl[i].usDurationTime + liModuualControl[i].ulStartTime) <= Form1.GetTimeStamp())
                            {
                                bool[] bControlData;
                                //string str;
                                liModuualControl[i].bControlStatus = ModualPoll.bGet_channel_Value<bool>(liModuualControl[i].sbModbusID, out bControlData, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                                //for (int j = 0; j < 8; j++)
                                //{ 
                                //    str = "d"+j.ToString();
                                //    if (str == liModuualControl[i].strOperationChannelName[0])
                                //    { 
                                //        liModuualControl[i].bControlData[j] =  !liModuualControl[i].bControlData[j];
                                //    }
                                //}
                                if (bNorth_South_Water_Mutual_Check (liModuualControl[i].sbModbusID,liModuualControl[i].strOperationChannelName[0]) && ControlMap.bControl_Map(!liModuualControl[i].bOpenMachine, liModuualControl[i].sbModbusID, liModuualControl[i].bControlData, liModuualControl[i].strOperationChannelName[0]))
                                {
                                    liModuualControl[i].bControlStatus = ControlMap.bDelege_Operation(bControlData);
                                }
                                liModuualControl.Remove(liModuualControl[i]);
                                break;
                            }
                        }
                    }
                }
                Thread.Sleep(100);
            }
        }
        public static Task vControl_Res_Poll()
        {
            vInit_Level_Config();
            while (true)
            {
                #region 东中转反馈和液位检测
                for (sbyte sbEastTransitPoolIndex = 0; sbEastTransitPoolIndex < AllPond.WestTransitPoolList.Count(); sbEastTransitPoolIndex++)
                {
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == true)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent < OPENCURRENT && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent != 0)
                        {
                            bool[] bControlData;

                            if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].iRefAlarmCnt < AllPond.EastTransitPoolList[sbEastTransitPoolIndex].MaxAlarmfeedback)
                            {
                                AllPond.EastTransitPoolList[sbEastTransitPoolIndex].iRefAlarmCnt++;
                            }
                            else
                            {
                                if (ModualPoll.bGet_channel_Value<bool>(
                                        AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID,
                                        out bControlData, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7") == true)
                                {
                                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex]
                                            .bClose_Machine(bControlData) == true)
                                    {
                                        ModualAlarm.vSet_Modual_Alarm(
                                            AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID,
                                            (ushort) ModualAlarm.eAlarmCode.ChannelControlError, true, 1,
                                            AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                                    }
                                }
                            }
                        }
                        else
                        {
                            AllPond.EastTransitPoolList[sbEastTransitPoolIndex].iRefAlarmCnt = 0;
                        }
                    }
                    if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadRefControl == true && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].bHadOpenPumb == false)
                    {
                        if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent > CLOSECURRENT && AllPond.EastTransitPoolList[sbEastTransitPoolIndex].dChannelCurrent != 0)
                        {
                            if (AllPond.EastTransitPoolList[sbEastTransitPoolIndex].iRefAlarmCnt < AllPond.EastTransitPoolList[sbEastTransitPoolIndex].MaxAlarmfeedback)
                            {
                                AllPond.EastTransitPoolList[sbEastTransitPoolIndex].iRefAlarmCnt++;
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(
                                    AllPond.EastTransitPoolList[sbEastTransitPoolIndex].byModbusID,
                                    (ushort) ModualAlarm.eAlarmCode.ChannelControlError, true, 1,
                                    AllPond.EastTransitPoolList[sbEastTransitPoolIndex].strChannelNumber);
                            }
                        }
                        else
                        {
                            AllPond.EastTransitPoolList[sbEastTransitPoolIndex].iRefAlarmCnt = 0;
                        }
                    }
                    Thread.Sleep(200);
                }
                if (AllPond.cEastTransitPool.cLevel.dCurrentlevel >= AllPond.cEastTransitPool.vSetMaxLevel || AllPond.cEastTransitPool.cLevel.dCurrentlevel <= AllPond.cEastTransitPool.vSetMinLevel)
                {
                    ModualAlarm.vSet_Modual_Alarm(AllPond.cEastTransitPool.cLevel.byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelLevelError, true, 1, AllPond.cEastTransitPool.cLevel.strChannelNumber);
                }
                else
                {
                    ModualAlarm.vSet_Modual_Alarm(AllPond.cEastTransitPool.cLevel.byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelLevelError, false, 1, AllPond.cEastTransitPool.cLevel.strChannelNumber);
                }
                Thread.Sleep(1000);
                #endregion 
                #region 西中转反馈和液位检测 
                for (sbyte sbWestTransitPoolIndex = 0; sbWestTransitPoolIndex < AllPond.WestTransitPoolList.Count(); sbWestTransitPoolIndex++)
                {
                    if (AllPond.WestTransitPoolList[sbWestTransitPoolIndex].bHadRefControl == true && AllPond.WestTransitPoolList[sbWestTransitPoolIndex].bHadOpenPumb == true)
                    {
                        if (AllPond.WestTransitPoolList[sbWestTransitPoolIndex].dChannelCurrent < OPENCURRENT && AllPond.WestTransitPoolList[sbWestTransitPoolIndex].dChannelCurrent != 0)
                        {
                            bool[] bControlData;

                            if (AllPond.WestTransitPoolList[sbWestTransitPoolIndex].iRefAlarmCnt < AllPond.WestTransitPoolList[sbWestTransitPoolIndex].MaxAlarmfeedback)
                            {
                                AllPond.WestTransitPoolList[sbWestTransitPoolIndex].iRefAlarmCnt++;
                            }
                            else
                            {
                                if (ModualPoll.bGet_channel_Value<bool>(AllPond.WestTransitPoolList[sbWestTransitPoolIndex].byModbusID,out bControlData, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7") == true)
                                {
                                    if (AllPond.WestTransitPoolList[sbWestTransitPoolIndex].bClose_Machine(bControlData) == true)
                                    {
                                        ModualAlarm.vSet_Modual_Alarm(AllPond.WestTransitPoolList[sbWestTransitPoolIndex].byModbusID,(ushort) ModualAlarm.eAlarmCode.ChannelControlError, true, 1,AllPond.WestTransitPoolList[sbWestTransitPoolIndex].strChannelNumber);
                                    }
                                }
                            }
                        }
                        else
                        {
                            AllPond.WestTransitPoolList[sbWestTransitPoolIndex].iRefAlarmCnt = 0;
                        }
                    }
                    if (AllPond.WestTransitPoolList[sbWestTransitPoolIndex].bHadRefControl == true && AllPond.WestTransitPoolList[sbWestTransitPoolIndex].bHadOpenPumb == false)
                    {

                        if (AllPond.WestTransitPoolList[sbWestTransitPoolIndex].dChannelCurrent > CLOSECURRENT &&
                            AllPond.WestTransitPoolList[sbWestTransitPoolIndex].dChannelCurrent != 0)
                        {
                            if (AllPond.WestTransitPoolList[sbWestTransitPoolIndex].iRefAlarmCnt < AllPond.WestTransitPoolList[sbWestTransitPoolIndex].MaxAlarmfeedback)
                            {
                                AllPond.WestTransitPoolList[sbWestTransitPoolIndex].iRefAlarmCnt++;
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(AllPond.WestTransitPoolList[sbWestTransitPoolIndex].byModbusID,(ushort) ModualAlarm.eAlarmCode.ChannelControlError, true, 1,AllPond.WestTransitPoolList[sbWestTransitPoolIndex].strChannelNumber);
                            }
                        }
                        else
                        {
                            AllPond.WestTransitPoolList[sbWestTransitPoolIndex].iRefAlarmCnt = 0;
                        }
                    }

                    Thread.Sleep(200);
                }
                if (AllPond.cWestTransitPool.cLevel.dCurrentlevel >= AllPond.cWestTransitPool.vSetMaxLevel || AllPond.cWestTransitPool.cLevel.dCurrentlevel <= AllPond.cWestTransitPool.vSetMinLevel)
                {
                    ModualAlarm.vSet_Modual_Alarm(AllPond.cWestTransitPool.cLevel.byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelLevelError, true, 1, AllPond.cWestTransitPool.cLevel.strChannelNumber);
                }
                else
                {
                    ModualAlarm.vSet_Modual_Alarm(AllPond.cWestTransitPool.cLevel.byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelLevelError, false, 1, AllPond.cWestTransitPool.cLevel.strChannelNumber);
                }

                Thread.Sleep(1000);
                #endregion 
                #region 沉砂池反馈和液位检测
                for (sbyte sbDesiltingPoolIndex = 0; sbDesiltingPoolIndex < AllPond.DesiltingPoolList.Count(); sbDesiltingPoolIndex++)
                {
                    if (AllPond.DesiltingPoolList[sbDesiltingPoolIndex].bHadRefControl == true && AllPond.DesiltingPoolList[sbDesiltingPoolIndex].bHadOpenPumb == true)
                    {//泵是开的
                        if (AllPond.DesiltingPoolList[sbDesiltingPoolIndex].dChannelCurrent < OPENCURRENT && AllPond.DesiltingPoolList[sbDesiltingPoolIndex].dChannelCurrent != 0)
                        {//电流小，当前电流也不等于0
                            bool[] bControlData;

                            if (AllPond.DesiltingPoolList[sbDesiltingPoolIndex].iRefAlarmCnt < AllPond.DesiltingPoolList[sbDesiltingPoolIndex].MaxAlarmfeedback)
                            {
                                AllPond.DesiltingPoolList[sbDesiltingPoolIndex].iRefAlarmCnt++;
                            }
                            else
                            {
                                if (ModualPoll.bGet_channel_Value<bool>(AllPond.DesiltingPoolList[sbDesiltingPoolIndex].byModbusID, out bControlData, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7") == true)
                                {//获取当前的开关情况
                                    if (AllPond.DesiltingPoolList[sbDesiltingPoolIndex].bClose_Machine(bControlData) == true)
                                    {//关闭池的操作，然后报警
                                        ModualAlarm.vSet_Modual_Alarm(AllPond.DesiltingPoolList[sbDesiltingPoolIndex].byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, AllPond.DesiltingPoolList[sbDesiltingPoolIndex].strChannelNumber);
                                    }
                                }
                            }
                        }
                        else
                        {
                            AllPond.DesiltingPoolList[sbDesiltingPoolIndex].iRefAlarmCnt = 0;
                        }
                    }
                    if (AllPond.DesiltingPoolList[sbDesiltingPoolIndex].bHadRefControl == true && AllPond.DesiltingPoolList[sbDesiltingPoolIndex].bHadOpenPumb == false)
                    {//泵是关的

                            if (AllPond.DesiltingPoolList[sbDesiltingPoolIndex].dChannelCurrent > CLOSECURRENT &&
                                AllPond.DesiltingPoolList[sbDesiltingPoolIndex].dChannelCurrent != 0)
                            {
                                if (AllPond.DesiltingPoolList[sbDesiltingPoolIndex].iRefAlarmCnt < AllPond.DesiltingPoolList[sbDesiltingPoolIndex].MaxAlarmfeedback)
                                {
                                    AllPond.DesiltingPoolList[sbDesiltingPoolIndex].iRefAlarmCnt++;
                                }
                                else
                                {
                                    ModualAlarm.vSet_Modual_Alarm(AllPond.DesiltingPoolList[sbDesiltingPoolIndex].byModbusID,(ushort) ModualAlarm.eAlarmCode.ChannelControlError, true, 1,AllPond.DesiltingPoolList[sbDesiltingPoolIndex].strChannelNumber);
                                }
                            }
                            else
                            {
                                AllPond.DesiltingPoolList[sbDesiltingPoolIndex].iRefAlarmCnt = 0;
                            }
                    }
                    Thread.Sleep(200);
                }                      
                if ( AllPond.cDesiltingPool.cLevel.dCurrentlevel >= AllPond.cDesiltingPool.vSetMaxLevel ||  AllPond.cDesiltingPool.cLevel.dCurrentlevel <= AllPond.cDesiltingPool.vSetMinLevel)
                {
                    ModualAlarm.vSet_Modual_Alarm(AllPond.cDesiltingPool.cLevel.byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelLevelError, true, 1, AllPond.cDesiltingPool.cLevel.strChannelNumber);
                }
                else
                { 
                    ModualAlarm.vSet_Modual_Alarm(AllPond.cDesiltingPool.cLevel.byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelLevelError, false, 1, AllPond.cDesiltingPool.cLevel.strChannelNumber);                    
                }
                Thread.Sleep(1000);
                #endregion
                #region 出料池反馈和液位检测
                #if !DEBUG_TEST
                for (sbyte sbDischargePoolIndex = 0; sbDischargePoolIndex < AllPond.DischargePoolList.Count(); sbDischargePoolIndex++)
                {
                    if (AllPond.DischargePoolList[sbDischargePoolIndex].bHadRefControl == true && AllPond.DischargePoolList[sbDischargePoolIndex].bHadOpenPumb == true)
                    {
                        if (AllPond.DischargePoolList[sbDischargePoolIndex].dChannelCurrent < OPENCURRENT && AllPond.DischargePoolList[sbDischargePoolIndex].dChannelCurrent != 0)
                        {
                            bool[] bControlData;

                            if (AllPond.DischargePoolList[sbDischargePoolIndex].iRefAlarmCnt < AllPond.DischargePoolList[sbDischargePoolIndex].MaxAlarmfeedback)
                            {
                                AllPond.DischargePoolList[sbDischargePoolIndex].iRefAlarmCnt++;
                            }
                            else
                            {
                                if (ModualPoll.bGet_channel_Value<bool>(
                                        AllPond.DischargePoolList[sbDischargePoolIndex].byModbusID, out bControlData,
                                        "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7") == true)
                                {
                                    if (AllPond.DischargePoolList[sbDischargePoolIndex].bClose_Machine(bControlData) == true)
                                    {
                                        ModualAlarm.vSet_Modual_Alarm(AllPond.DischargePoolList[sbDischargePoolIndex].byModbusID,(ushort) ModualAlarm.eAlarmCode.ChannelControlError, true, 1,AllPond.DischargePoolList[sbDischargePoolIndex].strChannelNumber);
                                    }
                                }
                            }
                        }
                        else
                        {
                            AllPond.DischargePoolList[sbDischargePoolIndex].iRefAlarmCnt = 0;
                        }
                    }
                    if (AllPond.DischargePoolList[sbDischargePoolIndex].bHadRefControl == true && AllPond.DischargePoolList[sbDischargePoolIndex].bHadOpenPumb == false)
                    {
                        if (AllPond.DischargePoolList[sbDischargePoolIndex].dChannelCurrent > CLOSECURRENT && AllPond.DischargePoolList[sbDischargePoolIndex].dChannelCurrent != 0)
                        {
                            if (AllPond.DischargePoolList[sbDischargePoolIndex].iRefAlarmCnt < AllPond.DischargePoolList[sbDischargePoolIndex].MaxAlarmfeedback)
                            {
                                AllPond.DischargePoolList[sbDischargePoolIndex].iRefAlarmCnt++;
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(AllPond.DischargePoolList[sbDischargePoolIndex].byModbusID,(ushort) ModualAlarm.eAlarmCode.ChannelControlError, true, 1,AllPond.DischargePoolList[sbDischargePoolIndex].strChannelNumber);
                            }
                        }
                        else
                        {
                            AllPond.DischargePoolList[sbDischargePoolIndex].iRefAlarmCnt = 0;
                        }
                    }
                    Thread.Sleep(200);
                }                      
                if ( AllPond.cDischargePool.cLevel.dCurrentlevel >= AllPond.cDischargePool.vSetMaxLevel ||  AllPond.cDischargePool.cLevel.dCurrentlevel <= AllPond.cDischargePool.vSetMinLevel)
                {
                    ModualAlarm.vSet_Modual_Alarm(AllPond.cDischargePool.cLevel.byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelLevelError, true, 1, AllPond.cDischargePool.cLevel.strChannelNumber);
                }
                else
                { 
                    ModualAlarm.vSet_Modual_Alarm(AllPond.cDischargePool.cLevel.byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelLevelError, false, 1, AllPond.cDischargePool.cLevel.strChannelNumber);                    
                }
                Thread.Sleep(1000);
                #endif
                #endregion
                #region 匀浆池反馈和液位检测
                for (sbyte sbSlurryPoolIndex = 0; sbSlurryPoolIndex < AllPond.SlurryPoolList.Count(); sbSlurryPoolIndex++)
                {
                    if (AllPond.SlurryPoolList[sbSlurryPoolIndex].bHadRefControl == true && AllPond.SlurryPoolList[sbSlurryPoolIndex].bHadOpenPumb == true)
                    {
                        if (AllPond.SlurryPoolList[sbSlurryPoolIndex].dChannelCurrent < OPENCURRENT && AllPond.SlurryPoolList[sbSlurryPoolIndex].dChannelCurrent != 0)
                        {
                            bool[] bControlData;

                            if (AllPond.SlurryPoolList[sbSlurryPoolIndex].iRefAlarmCnt < AllPond.SlurryPoolList[sbSlurryPoolIndex].MaxAlarmfeedback)
                            {
                                AllPond.SlurryPoolList[sbSlurryPoolIndex].iRefAlarmCnt++;
                            }
                            else
                            {
                                if (ModualPoll.bGet_channel_Value<bool>(AllPond.SlurryPoolList[sbSlurryPoolIndex].byModbusID, out bControlData, "d0","d1", "d2", "d3", "d4", "d5", "d6", "d7") == true)
                                {
                                    if (AllPond.SlurryPoolList[sbSlurryPoolIndex].bClose_Machine(bControlData) == true)
                                    {
                                        ModualAlarm.vSet_Modual_Alarm(AllPond.SlurryPoolList[sbSlurryPoolIndex].byModbusID,(ushort) ModualAlarm.eAlarmCode.ChannelControlError, true, 1,AllPond.SlurryPoolList[sbSlurryPoolIndex].strChannelNumber);
                                    }
                                }
                            }
                        }
                        else
                        {
                            AllPond.SlurryPoolList[sbSlurryPoolIndex].iRefAlarmCnt = 0;
                        }
                    }
                    if (AllPond.SlurryPoolList[sbSlurryPoolIndex].bHadRefControl == true && AllPond.SlurryPoolList[sbSlurryPoolIndex].bHadOpenPumb == false)
                    {
                        if (AllPond.SlurryPoolList[sbSlurryPoolIndex].dChannelCurrent > CLOSECURRENT && AllPond.SlurryPoolList[sbSlurryPoolIndex].dChannelCurrent != 0)
                        {
                            if (AllPond.SlurryPoolList[sbSlurryPoolIndex].iRefAlarmCnt < AllPond.SlurryPoolList[sbSlurryPoolIndex].MaxAlarmfeedback)
                            {
                                AllPond.SlurryPoolList[sbSlurryPoolIndex].iRefAlarmCnt++;
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(AllPond.SlurryPoolList[sbSlurryPoolIndex].byModbusID,(ushort) ModualAlarm.eAlarmCode.ChannelControlError, true, 1,AllPond.SlurryPoolList[sbSlurryPoolIndex].strChannelNumber);
                            }
                        }
                        else
                        {
                            AllPond.SlurryPoolList[sbSlurryPoolIndex].iRefAlarmCnt = 0;
                        }
                    }
                    Thread.Sleep(200);
                }                      
                if ( AllPond.cSlurryPool.cLevel.dCurrentlevel >= AllPond.cSlurryPool.vSetMaxLevel ||  AllPond.cSlurryPool.cLevel.dCurrentlevel <= AllPond.cSlurryPool.vSetMinLevel)
                {
                    ModualAlarm.vSet_Modual_Alarm(AllPond.cSlurryPool.cLevel.byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelLevelError, true, 1, AllPond.cSlurryPool.cLevel.strChannelNumber);
                }
                else
                { 
                    ModualAlarm.vSet_Modual_Alarm(AllPond.cSlurryPool.cLevel.byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelLevelError, false, 1, AllPond.cSlurryPool.cLevel.strChannelNumber);                    
                }
                Thread.Sleep(1000);
                #endregion
                #region 八角池反馈和液位检测
                #if !DEBUG_TEST
                for (sbyte sbOctagonalPoolIndex = 0; sbOctagonalPoolIndex < AllPond.OctagonalPoolList.Count(); sbOctagonalPoolIndex++)
                {
                    if (AllPond.OctagonalPoolList[sbOctagonalPoolIndex].bHadRefControl == true && AllPond.OctagonalPoolList[sbOctagonalPoolIndex].bHadOpenPumb == true)
                    {
                        if (AllPond.OctagonalPoolList[sbOctagonalPoolIndex].dChannelCurrent < OPENCURRENT && AllPond.OctagonalPoolList[sbOctagonalPoolIndex].dChannelCurrent != 0)
                        {
                            bool[] bControlData;

                            if (AllPond.OctagonalPoolList[sbOctagonalPoolIndex].iRefAlarmCnt < AllPond.OctagonalPoolList[sbOctagonalPoolIndex].MaxAlarmfeedback)
                            {
                                AllPond.OctagonalPoolList[sbOctagonalPoolIndex].iRefAlarmCnt++;
                            }
                            else
                            {
                                if (ModualPoll.bGet_channel_Value<bool>(AllPond.OctagonalPoolList[sbOctagonalPoolIndex].byModbusID, out bControlData,"d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7") == true)
                                {
                                    if (AllPond.OctagonalPoolList[sbOctagonalPoolIndex].bClose_Machine(bControlData) == true)
                                    {
                                        ModualAlarm.vSet_Modual_Alarm( AllPond.OctagonalPoolList[sbOctagonalPoolIndex].byModbusID,(ushort) ModualAlarm.eAlarmCode.ChannelControlError, true, 1,AllPond.OctagonalPoolList[sbOctagonalPoolIndex].strChannelNumber);
                                    }
                                }
                            }
                        }
                        else
                        {
                            AllPond.OctagonalPoolList[sbOctagonalPoolIndex].iRefAlarmCnt = 0;
                        }
                    }
                    if (AllPond.OctagonalPoolList[sbOctagonalPoolIndex].bHadRefControl == true && AllPond.OctagonalPoolList[sbOctagonalPoolIndex].bHadOpenPumb == false)
                    {
                        if (AllPond.OctagonalPoolList[sbOctagonalPoolIndex].dChannelCurrent > CLOSECURRENT && AllPond.OctagonalPoolList[sbOctagonalPoolIndex].dChannelCurrent != 0)
                        {
                            if (AllPond.OctagonalPoolList[sbOctagonalPoolIndex].iRefAlarmCnt < AllPond.OctagonalPoolList[sbOctagonalPoolIndex].MaxAlarmfeedback)
                            {
                                AllPond.OctagonalPoolList[sbOctagonalPoolIndex].iRefAlarmCnt++;
                            }
                            else
                            {
                                ModualAlarm.vSet_Modual_Alarm(AllPond.OctagonalPoolList[sbOctagonalPoolIndex].byModbusID,(ushort) ModualAlarm.eAlarmCode.ChannelControlError, true, 1,AllPond.OctagonalPoolList[sbOctagonalPoolIndex].strChannelNumber);
                            }
                        }
                        else
                        {
                            AllPond.OctagonalPoolList[sbOctagonalPoolIndex].iRefAlarmCnt = 0;
                        }
                    }

                }                      
                if ( AllPond.cOctagonalPool.cLevel.dCurrentlevel >= AllPond.cOctagonalPool.vSetMaxLevel ||  AllPond.cOctagonalPool.cLevel.dCurrentlevel <= AllPond.cOctagonalPool.vSetMinLevel)
                {
                    ModualAlarm.vSet_Modual_Alarm(AllPond.cOctagonalPool.cLevel.byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelLevelError, true, 1, AllPond.cOctagonalPool.cLevel.strChannelNumber);
                }
                else
                { 
                    ModualAlarm.vSet_Modual_Alarm(AllPond.cOctagonalPool.cLevel.byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelLevelError, false, 1, AllPond.cOctagonalPool.cLevel.strChannelNumber);                    
                }
                Thread.Sleep(1000);  
                #endif
                #endregion
            }
        }
        public static bool bOperation_Machine(bool bOpenMachine, byte sbModbusID,bool[] bControlData,bool[] bControlBit,out bool bHadOpenMachine, byte byResModualID,string stResChannel)
        {
            bool bControlStatus = true;
            if (bOpenMachine == true)
            {
                bHadOpenMachine = false;
            }
            else
            {
                bHadOpenMachine = true;
            }
            if (ModualPoll.bSet_All_Channel_Value(sbModbusID, bControlData) == true)
            {
                if (bOpenMachine == true && stResChannel != null)
                {
                    //double[] dConvertData;
                    bHadOpenMachine = true;
                    //Thread.Sleep(2000);
                    //if (ModualPoll.bGet_channel_Value<double>(byResModualID, out dConvertData, stResChannel) == true)
                    //{
                    //    if (dConvertData[0] > OPENCURRENT && bControlStatus == true)
                    //    {
                    //        bControlStatus = true;
                    //    }
                    //    else
                    //    {
                    //        bControlStatus = false;
                    //    }
                    //}
                }
                else if (bOpenMachine == false && stResChannel != null)
                {
                    //double[] dConvertData;
                    bHadOpenMachine = false;
                    //Thread.Sleep(2000);
                    //if (ModualPoll.bGet_channel_Value<double>(byResModualID, out dConvertData, stResChannel) == true)
                    //{
                    //    if (dConvertData[0] < CLOSECURRENT && bControlStatus == true)
                    //    {
                    //        bControlStatus = true;
                    //    }
                    //    else
                    //    {
                    //        bControlStatus = false;
                    //    }
                    //}
                }
                else
                {
                    bControlStatus = true;
                }
            }
            else
            {
                bControlStatus = false;
            }
            for (int i = 0; i < bControlBit.Count(); i++)
            {
                string str = "d" + i.ToString();
                if (bControlBit[i] == true)
                {
                    if (bControlStatus == true)
                        ModualAlarm.vSet_Modual_Alarm(sbModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, false, 1, str);
                    else
                        ModualAlarm.vSet_Modual_Alarm(sbModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelControlError, true, 1, str);
                }
            }
            ModualPoll.vSend_Actual_Data(sbModbusID);
            return bControlStatus;
        }
        public static void vDelete_Same_Control(ModualCntrol cModualCntrol)
        {
            for (sbyte i = 0; i < liModuualControl.Count; i++)
            {
                if (liModuualControl[i].sbModbusID == cModualCntrol.sbModbusID)
                {
                    if (Enumerable.SequenceEqual(liModuualControl[i].bControlBit, cModualCntrol.bControlBit))
                    {
                        liModuualControl.Remove(liModuualControl[i]);
                    }
                }
            }
        }
        public static void vPoolLevelParse(string stConfigString, out string stResponseStrign)
        {
            pcCfgRoot cCfgRoot = new pcCfgRoot();
            var jsonObj = new JObject();
            try
            {
                cCfgRoot = JsonConvert.DeserializeObject<pcCfgRoot>(stConfigString);
                jsonObj = JObject.Parse(stConfigString);
                for (int i = 0; i < cCfgRoot.ss.Count; i++)
                {
                    pcLiquidLevelConfig cLiquidLevelConfig = new pcLiquidLevelConfig
                    {
                        byModbusID = byte.Parse(cCfgRoot.ss[i].addr),
                        dUpLevel = double.Parse(cCfgRoot.ss[i].cfg.upper),
                        dDownLevel = double.Parse(cCfgRoot.ss[i].cfg.down)
                    };

                    for (int j = 0; j < 8; j++)
                    {
                        string strChannelString = "d" + j.ToString();
                        if (jsonObj["ss"][i]["cfg"].Value<string>("name") == strChannelString)
                        {
                            cLiquidLevelConfig.stChannelNumber = strChannelString;
                            jsonObj["ss"][i]["cfg"][strChannelString] = 1;
                            break;
                        }
                    }
                    vSet_Pool_Alarm_Level(cLiquidLevelConfig.byModbusID,cLiquidLevelConfig.dUpLevel,cLiquidLevelConfig.dDownLevel,cLiquidLevelConfig.stChannelNumber);             
                    if (jsonObj["ss"][i]["cfg"]["ts"] != null)
                    {
                        jsonObj["ss"][i]["cfg"]["ts"] = Form1.GetTimeStamp();
                    }
                    cPoolLevelConfig.Add(cLiquidLevelConfig);
                }
            }
            catch (Exception exception)
            {
                Form1.totxt.Log(exception + "Cfg Mqtt Parse Fail");
                stResponseStrign = "";
            }
            finally
            {
                stResponseStrign = jsonObj.ToString();
            }
        }
        public static void vSet_Pool_Alarm_Level(byte byModbusID,double dMaxLevel,double dMinLevel,string strChannelName)
        {
            if (byModbusID == AllPond.cEastTransitPool.cLevel.byModbusID && ((IList<string>)AllPond.cEastTransitPool.cLevel.strChannelNumber).Contains(strChannelName) == true)
            {
                AllPond.cEastTransitPool.vSetMaxLevel = dMaxLevel;
                AllPond.cEastTransitPool.vSetMinLevel = dMinLevel;
                pcConfig.WriteConfig("东中转池配置", "报警最高液位", AllPond.cEastTransitPool.vSetMaxLevel.ToString());
                pcConfig.WriteConfig("东中转池配置", "报警最低液位", AllPond.cEastTransitPool.vSetMinLevel.ToString());
            }
            else if (byModbusID == AllPond.cWestTransitPool.cLevel.byModbusID && ((IList<string>)AllPond.cWestTransitPool.cLevel.strChannelNumber).Contains(strChannelName) == true)
            {
                AllPond.cWestTransitPool.vSetMaxLevel = dMaxLevel;
                AllPond.cWestTransitPool.vSetMinLevel = dMinLevel;
                pcConfig.WriteConfig("西中转池配置", "报警最高液位", AllPond.cWestTransitPool.vSetMaxLevel.ToString());
                pcConfig.WriteConfig("西中转池配置", "报警最低液位", AllPond.cWestTransitPool.vSetMinLevel.ToString());
            }
            else if (byModbusID == AllPond.cSlurryPool.cLevel.byModbusID && ((IList<string>)AllPond.cSlurryPool.cLevel.strChannelNumber).Contains(strChannelName) == true)
            {
                AllPond.cSlurryPool.vSetMaxLevel = dMaxLevel;
                AllPond.cSlurryPool.vSetMinLevel = dMinLevel;
                pcConfig.WriteConfig("匀浆池配置", "报警最高液位", AllPond.cSlurryPool.vSetMaxLevel.ToString());
                pcConfig.WriteConfig("匀浆池配置", "报警最低液位", AllPond.cSlurryPool.vSetMinLevel.ToString());
            }
            else if (byModbusID == AllPond.cDesiltingPool.cLevel.byModbusID && ((IList<string>)AllPond.cDesiltingPool.cLevel.strChannelNumber).Contains(strChannelName) == true)
            {
                AllPond.cDesiltingPool.vSetMaxLevel = dMaxLevel;
                AllPond.cDesiltingPool.vSetMinLevel = dMinLevel;
                pcConfig.WriteConfig("沉砂池池配置", "报警最高液位", AllPond.cDesiltingPool.vSetMaxLevel.ToString());
                pcConfig.WriteConfig("沉砂池池配置", "报警最低液位", AllPond.cDesiltingPool.vSetMinLevel.ToString());
            }
            else if (byModbusID == AllPond.cOctagonalPool.cLevel.byModbusID && ((IList<string>)AllPond.cOctagonalPool.cLevel.strChannelNumber).Contains(strChannelName) == true)
            {
                AllPond.cOctagonalPool.vSetMaxLevel = dMaxLevel;
                AllPond.cOctagonalPool.vSetMinLevel = dMinLevel;
                pcConfig.WriteConfig("八角池配置", "报警最高液位", AllPond.cOctagonalPool.vSetMaxLevel.ToString());
                pcConfig.WriteConfig("八角池配置", "报警最低液位", AllPond.cOctagonalPool.vSetMinLevel.ToString());
            }
            else if (byModbusID == AllPond.cDischargePool.cLevel.byModbusID && ((IList<string>)AllPond.cDischargePool.cLevel.strChannelNumber).Contains(strChannelName) == true)
            {
                AllPond.cDischargePool.vSetMaxLevel = dMaxLevel;
                AllPond.cDischargePool.vSetMinLevel = dMinLevel;
                pcConfig.WriteConfig("出料池配置", "报警最高液位", AllPond.cDischargePool.vSetMaxLevel.ToString());
                pcConfig.WriteConfig("出料池配置", "报警最低液位", AllPond.cDischargePool.vSetMinLevel.ToString());
            }           
        }
        public static void vInit_Level_Config()
        {
            if (filConfigFiles.Length == 0)
            {

                pcConfig.WriteConfig("东中转池配置", "报警最高液位", "8");
                pcConfig.WriteConfig("东中转池配置", "报警最低液位", "1");

                pcConfig.WriteConfig("西中转池配置", "报警最高液位", "8");
                pcConfig.WriteConfig("西中转池配置", "报警最低液位", "1");

                pcConfig.WriteConfig("匀浆池配置", "报警最高液位", "8");
                pcConfig.WriteConfig("匀浆池配置", "报警最低液位", "1");

                pcConfig.WriteConfig("沉砂池池配置", "报警最高液位", "8");
                pcConfig.WriteConfig("沉砂池池配置", "报警最低液位", "1");

                pcConfig.WriteConfig("八角池配置", "报警最高液位", "8");
                pcConfig.WriteConfig("八角池配置", "报警最低液位", "1");
 
                pcConfig.WriteConfig("出料池配置", "报警最高液位", "8");
                pcConfig.WriteConfig("出料池配置", "报警最低液位", "1");               

                AllPond.cEastTransitPool.vSetMaxLevel = pcConfig.ReadConfig<double>("东中转池配置", "报警最高液位");
                AllPond.cEastTransitPool.vSetMinLevel = pcConfig.ReadConfig<double>("东中转池配置", "报警最低液位");

                AllPond.cWestTransitPool.vSetMaxLevel = pcConfig.ReadConfig<double>("西中转池配置", "报警最高液位");
                AllPond.cWestTransitPool.vSetMinLevel = pcConfig.ReadConfig<double>("西中转池配置", "报警最低液位");

                AllPond.cSlurryPool.vSetMaxLevel = pcConfig.ReadConfig<double>("匀浆池配置", "报警最高液位");
                AllPond.cSlurryPool.vSetMinLevel = pcConfig.ReadConfig<double>("匀浆池配置", "报警最低液位");

                AllPond.cDesiltingPool.vSetMaxLevel = pcConfig.ReadConfig<double>("沉砂池池配置", "报警最高液位");
                AllPond.cDesiltingPool.vSetMinLevel = pcConfig.ReadConfig<double>("沉砂池池配置", "报警最低液位");               

                AllPond.cOctagonalPool.vSetMaxLevel = pcConfig.ReadConfig<double>("八角池配置", "报警最高液位");
                AllPond.cOctagonalPool.vSetMinLevel = pcConfig.ReadConfig<double>("八角池配置", "报警最低液位");   

                AllPond.cDischargePool.vSetMaxLevel = pcConfig.ReadConfig<double>("出料池配置", "报警最高液位");
                AllPond.cDischargePool.vSetMinLevel = pcConfig.ReadConfig<double>("出料池配置", "报警最低液位");             
            }
            else
            {
                AllPond.cEastTransitPool.vSetMaxLevel = pcConfig.ReadConfig<double>("东中转池配置", "报警最高液位");
                AllPond.cEastTransitPool.vSetMinLevel = pcConfig.ReadConfig<double>("东中转池配置", "报警最低液位");

                AllPond.cWestTransitPool.vSetMaxLevel = pcConfig.ReadConfig<double>("西中转池配置", "报警最高液位");
                AllPond.cWestTransitPool.vSetMinLevel = pcConfig.ReadConfig<double>("西中转池配置", "报警最低液位");

                AllPond.cSlurryPool.vSetMaxLevel = pcConfig.ReadConfig<double>("匀浆池配置", "报警最高液位");
                AllPond.cSlurryPool.vSetMinLevel = pcConfig.ReadConfig<double>("匀浆池配置", "报警最低液位");

                AllPond.cDesiltingPool.vSetMaxLevel = pcConfig.ReadConfig<double>("沉砂池池配置", "报警最高液位");
                AllPond.cDesiltingPool.vSetMinLevel = pcConfig.ReadConfig<double>("沉砂池池配置", "报警最低液位");               

                AllPond.cOctagonalPool.vSetMaxLevel = pcConfig.ReadConfig<double>("八角池配置", "报警最高液位");
                AllPond.cOctagonalPool.vSetMinLevel = pcConfig.ReadConfig<double>("八角池配置", "报警最低液位");   

                AllPond.cDischargePool.vSetMaxLevel = pcConfig.ReadConfig<double>("出料池配置", "报警最高液位");
                AllPond.cDischargePool.vSetMinLevel = pcConfig.ReadConfig<double>("出料池配置", "报警最低液位");    
            }
        }
        public static bool bNorth_South_Water_Mutual_Check(byte byModbusID, string strOperationChannelsName)
        {
            bool bCheckStatus = true;
            if (byModbusID == AllPond.cEastTransitPool.cSouthWater.byModbusID && strOperationChannelsName == AllPond.cEastTransitPool.cSouthWater.strOperationNumber)
            {
                bCheckStatus = false;
                if (AllPond.cEastTransitPool.cNorthWater.bHadOpenPumb == false && AllPond.cWestTransitPool.cNorthWater.bHadOpenPumb == false && AllPond.cWestTransitPool.cSouthWater.bHadOpenPumb == false)
                {
                    bCheckStatus = true;
                }
            }
            else if (byModbusID == AllPond.cEastTransitPool.cNorthWater.byModbusID && strOperationChannelsName == AllPond.cEastTransitPool.cNorthWater.strOperationNumber)
            {
                 bCheckStatus = false;
                if (AllPond.cEastTransitPool.cSouthWater.bHadOpenPumb == false && AllPond.cWestTransitPool.cNorthWater.bHadOpenPumb == false && AllPond.cWestTransitPool.cSouthWater.bHadOpenPumb == false)
                {
                    bCheckStatus = true;
                }
            }
            else if (byModbusID == AllPond.cWestTransitPool.cSouthWater.byModbusID && strOperationChannelsName == AllPond.cWestTransitPool.cSouthWater.strOperationNumber)
            {
                 bCheckStatus = false;
                if (AllPond.cWestTransitPool.cNorthWater.bHadOpenPumb == false && AllPond.cEastTransitPool.cSouthWater.bHadOpenPumb == false && AllPond.cEastTransitPool.cNorthWater.bHadOpenPumb == false)
                {
                    bCheckStatus = true;
                }
            }
            else if (byModbusID == AllPond.cWestTransitPool.cNorthWater.byModbusID && strOperationChannelsName == AllPond.cWestTransitPool.cNorthWater.strOperationNumber)
            {
                 bCheckStatus = false;
                if (AllPond.cWestTransitPool.cSouthWater.bHadOpenPumb == false && AllPond.cEastTransitPool.cSouthWater.bHadOpenPumb == false && AllPond.cEastTransitPool.cNorthWater.bHadOpenPumb == false)
                {
                    bCheckStatus = true;
                }
            }
            else
                bCheckStatus = true;
            if (bCheckStatus == false )
            { 
                ModualPoll.vSend_Actual_Data(byModbusID);
            }
            return bCheckStatus;
        }
    }
}